Poly1305 (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.crypto.macs

## Class Poly1305

- java.lang.Object
- - org.bouncycastle.crypto.macs.Poly1305

- All Implemented Interfaces:
    Mac

      public class Poly1305
      extends java.lang.Object
      implements Mac

  Poly1305 message authentication code, designed by D. J. Bernstein.

  Poly1305 computes a 128-bit (16 bytes) authenticator, using a 128 bit nonce and a 256 bit key consisting of a 128 bit key applied to an underlying cipher, and a 128 bit key (with 106 effective key bits) used in the authenticator.

  The polynomial calculation in this implementation is adapted from the public domain poly1305-donna-unrolled C implementation by Andrew M (@floodyberry).

  See Also:
    `Poly1305KeyGenerator`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Poly1305()` Constructs a Poly1305 MAC, where the key passed to init() will be used directly.
    `Poly1305(BlockCipher cipher)` Constructs a Poly1305 MAC, using a 128 bit block cipher.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Compute the final stage of the MAC writing the output to the out parameter.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
    `int` | `getMacSize()` Return the block size for this MAC (in bytes).
    `void` | `init(CipherParameters params)` Initialises the Poly1305 MAC.
    `void` | `reset()` Reset the MAC.
    `void` | `update(byte in)` add a single byte to the mac for processing.
    `void` | `update(byte[] in, int inOff, int len)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Poly1305

          public Poly1305()

      Constructs a Poly1305 MAC, where the key passed to init() will be used directly.

    - #### Poly1305

          public Poly1305(BlockCipher cipher)

      Constructs a Poly1305 MAC, using a 128 bit block cipher.

  - ### Method Detail

    - #### init

          public void init(CipherParameters params)
                    throws java.lang.IllegalArgumentException

      Initialises the Poly1305 MAC.
      Specified by:
        `init` in interface `Mac`
      Parameters:
        `params` - if used with a block cipher, then a `ParametersWithIV` containing a 128 bit nonce and a `KeyParameter` with a 256 bit key complying to the `Poly1305 key format`, otherwise just the `KeyParameter`.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Mac`
      Return the name of the algorithm the MAC implements.
      Specified by:
        `getAlgorithmName` in interface `Mac`
      Returns:
        the name of the algorithm the MAC implements.

    - #### getMacSize

          public int getMacSize()

      Description copied from interface: `Mac`
      Return the block size for this MAC (in bytes).
      Specified by:
        `getMacSize` in interface `Mac`
      Returns:
        the block size for this MAC in bytes.

    - #### update

          public void update(byte in)
                      throws java.lang.IllegalStateException

      Description copied from interface: `Mac`
      add a single byte to the mac for processing.
      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the byte to be processed.
      Throws:
        `java.lang.IllegalStateException` - if the MAC is not initialised.

    - #### update

          public void update(byte[] in,
                    int inOff,
                    int len)
                      throws DataLengthException,
                             java.lang.IllegalStateException

      Specified by:
        `update` in interface `Mac`
      Parameters:
        `in` - the array containing the input.
        `inOff` - the index in the array the data begins at.
        `len` - the length of the input starting at inOff.
      Throws:
        `DataLengthException` - if there isn't enough data in in.
        `java.lang.IllegalStateException` - if the MAC is not initialised.

    - #### doFinal

          public int doFinal(byte[] out,
                    int outOff)
                      throws DataLengthException,
                             java.lang.IllegalStateException

      Description copied from interface: `Mac`
      Compute the final stage of the MAC writing the output to the out parameter.

      doFinal leaves the MAC in the same state it was after the last init.

      Specified by:
        `doFinal` in interface `Mac`
      Parameters:
        `out` - the array the MAC is to be output to.
        `outOff` - the offset into the out buffer the output is to start at.
      Throws:
        `DataLengthException` - if there isn't enough space in out.
        `java.lang.IllegalStateException` - if the MAC is not initialised.

    - #### reset

          public void reset()

      Description copied from interface: `Mac`
      Reset the MAC. At the end of resetting the MAC should be in the in the same state it was after the last init (if there was one).
      Specified by:
        `reset` in interface `Mac`